DCMTK: IODSOPCommonModule Class Reference

DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Static Private Attributes | List of all members
IODSOPCommonModule Class Reference

Class representing the SOP Common Module. More...

Inheritance diagram for IODSOPCommonModule:

## Public Member Functions
| IODSOPCommonModule (OFshared_ptr< DcmItem > item, OFshared_ptr< IODRules > rules)
| Constructor.
| IODSOPCommonModule ()
| Constructor.
virtual | ~IODSOPCommonModule ()
| Destructor.
virtual void | resetRules ()
| Resets rules to their original values.
virtual void | inventMissing ()
| Set missing values by inventing "default values".
virtual OFString | getName () const
| Get name of module.
virtual void | ensureInstanceUID (const OFBool correctInvalid=OFFalse)
| Make sure that the module contains a SOP Instance UID, i.e. a new one is created if empty.
virtual OFCondition | getSOPClassUID (OFString &value, const signed long pos=0) const
| Get SOP Class UID.
virtual OFCondition | getSOPInstanceUID (OFString &value, const signed long pos=0) const
| Get SOP Instance UID.
virtual OFCondition | getInstanceCreatorUID (OFString &value, const signed long pos=0) const
| Get Instance Creator UID.
virtual OFCondition | getTimezoneOffsetFromUTC (OFString &value, const signed long pos=0) const
| Get Timeho e Offset from UTC.
virtual OFCondition | getSpecificCharacterSet (OFString &value, const signed long pos=0) const
| Get Specific Character Set.
virtual OFCondition | getInstanceCreationDate (OFString &value, const signed long pos=0) const
| Get Instance Creation Date.
virtual OFCondition | getInstanceCreationTime (OFString &value, const signed long pos=0) const
| Get Instance Creation Time.
virtual OFCondition | setSOPInstanceUID (const OFString &value, const OFBool checkValue=OFTrue)
| Set SOP Instance UID.
virtual OFCondition | setSOPClassUID (const OFString &value, const OFBool checkValue=OFTrue)
| Set SOP Class UID.
virtual OFCondition | setSpecificCharacterSet (const OFString &value, const OFBool checkValue=OFTrue)
| Set Specific Character Set.
virtual OFCondition | setInstanceCreationDate (const OFString &value, const OFBool checkValue=OFTrue)
| Set Instance Creation Date.
virtual OFCondition | setInstanceCreationTime (const OFString &value, const OFBool checkValue=OFTrue)
| Set Instance Creation Date.
virtual OFCondition | setInstanceCreatorUID (const OFString &value, const OFBool checkValue=OFTrue)
| Set Instance Creator UID.
virtual OFCondition | setTimeZoneOffsetFromUTC (const OFString &value, const OFBool checkValue=OFTrue) const
| Set Timezone Offset From UTC.
Public Member Functions inherited from IODModule
| IODModule (OFshared_ptr< DcmItem > item, OFshared_ptr< IODRules > rules)
| Constructor.
| IODModule ()
| Constructor.
| IODModule (const IODModule &rhs)
| Copy constructor, creates shallow copy.
IODModule & | operator= (const IODModule &rhs)
| Assignment operator, creates shallow copy.
| ~IODModule ()
| Destructor.
Public Member Functions inherited from IODComponent
| IODComponent (OFshared_ptr< DcmItem > item, OFshared_ptr< IODRules > rules, IODComponent *parent=NULL)
| Constructor.
| IODComponent (IODComponent *parent=NULL)
| Constructor, creates rules and item from scratch.
IODComponent & | operator= (const IODComponent &rhs)
| Assignment operator, copies contained item and rule set from rhs to "this" attribute set.
| IODComponent (const IODComponent &rhs)
| Copy constructor, copies reference to contained item and rule set to "this" attribute set.
virtual | ~IODComponent ()
| Virtual Destructor.
virtual void | clearData ()
| Clear all attributes from the data that are handled by this module.
OFshared_ptr< IODRules > | getRules ()
| Get rules handled by this module.
virtual void | makeOptional ()
| Make component optional by turning all attributes requirement types of it to type 3.
DcmItem & | getData ()
| Get the data handled by this module.
virtual OFCondition | read (DcmItem &source, const OFBool clearOldData=OFTrue)
| Read attributes from given item into this class.
virtual OFCondition | write (DcmItem &destination)
| Write attributes from this class into given item.
virtual OFCondition | check (const OFBool quiet=OFFalse)
| Check whether this component's data satisfies the underlying rules.
virtual int | compare (const IODComponent &rhs) const
| Comparison operator for IOD Components.
virtual bool | getValueCheckOnWrite () const
| Get whether attribute value errors will be handled as errors on writing.
virtual void | setValueCheckOnWrite (const OFBool checkValue)
| Set whether attribute values should be checked on writing, i.e.

## Static Private Attributes
static const OFString | m_ModuleName
| Name of this module ("SOPCommonModule").

## Additional Inherited Members
Static Public Member Functions inherited from IODComponent
static OFCondition | read (DcmItem &source, IODRules &rules, DcmItem &destination, const OFString &componentName)
| Static helper function that reads attributes from given item into destination item, as determined by the provided rules and component name.
static OFCondition | write (DcmItem &source, IODRules &rules, DcmItem &destination, const OFString &componentName, const OFBool checkValue)
| Static helper function that writes attributes from given item into destination item, as determined by the provided rules and component name.
Protected Attributes inherited from IODComponent
OFshared_ptr< DcmItem > | m_Item
| Shared pointer to the data handled by this class.
OFshared_ptr< IODRules > | m_Rules
| Rules describing the attributes governed by this class.
IODComponent * | m_Parent
| The parent component (may be NULL) of this class.
OFBool | m_CheckValueOnWrite
| Denotes whether attribute values should be checked on writing, i.e.

## Detailed Description

Class representing the SOP Common Module.

Supported Attributes:

SOP Class UID: (UI, 1, 1) SOP Instance UID: (UI, 1, 1) Specific Character Set: (CS, 1-n, 1C) Instance Creation Date: (DA, 1, 3) Instance Creation Time: (TM, 1, 3) Instance Creator UID: (UI, 1, 3) Timezone Offset from UTC: (SH, 1, 3)

## Constructor & Destructor Documentation

## ◆ IODSOPCommonModule()

IODSOPCommonModule::IODSOPCommonModule | ( | OFshared_ptr< DcmItem > | item,
|  | OFshared_ptr< IODRules > | rules )

Constructor.

Parameters

  item | The item to be used for data storage. If NULL, the class creates an empty data container.
  rules | The rule set for this class. If NULL, the class creates one from scratch and adds its values.

## Member Function Documentation

## ◆ ensureInstanceUID()

virtual void IODSOPCommonModule::ensureInstanceUID | ( | const OFBool | correctInvalid = OFFalse | ) |
| virtual

Make sure that the module contains a SOP Instance UID, i.e. a new one is created if empty.

An invalid UID is corrected if desired.

Parameters

  correctInvalid | Correct invalid UID if OFTrue, otherwise do nothing

## ◆ getInstanceCreationDate()

virtual OFCondition IODSOPCommonModule::getInstanceCreationDate | ( | OFString & | value,
|  | const signed long | pos = 0 ) const
| virtual

Get Instance Creation Date.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getInstanceCreationTime()

virtual OFCondition IODSOPCommonModule::getInstanceCreationTime | ( | OFString & | value,
|  | const signed long | pos = 0 ) const
| virtual

Get Instance Creation Time.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getInstanceCreatorUID()

virtual OFCondition IODSOPCommonModule::getInstanceCreatorUID | ( | OFString & | value,
|  | const signed long | pos = 0 ) const
| virtual

Get Instance Creator UID.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getName()

virtual OFString IODSOPCommonModule::getName | ( |  | ) | const
| virtual

Get name of module.

Returns
  Name of the module ("SOPCommonModule")

Implements IODComponent.

## ◆ getSOPClassUID()

virtual OFCondition IODSOPCommonModule::getSOPClassUID | ( | OFString & | value,
|  | const signed long | pos = 0 ) const
| virtual

Get SOP Class UID.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getSOPInstanceUID()

virtual OFCondition IODSOPCommonModule::getSOPInstanceUID | ( | OFString & | value,
|  | const signed long | pos = 0 ) const
| virtual

Get SOP Instance UID.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getSpecificCharacterSet()

virtual OFCondition IODSOPCommonModule::getSpecificCharacterSet | ( | OFString & | value,
|  | const signed long | pos = 0 ) const
| virtual

Get Specific Character Set.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getTimezoneOffsetFromUTC()

virtual OFCondition IODSOPCommonModule::getTimezoneOffsetFromUTC | ( | OFString & | value,
|  | const signed long | pos = 0 ) const
| virtual

Get Timeho e Offset from UTC.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal if successful, an error code otherwise

## ◆ inventMissing()

virtual void IODSOPCommonModule::inventMissing | ( |  | ) |
| virtual

Set missing values by inventing "default values".

Automatically called during write() by IODComponent.

Reimplemented from IODComponent.

## ◆ setInstanceCreationDate()

virtual OFCondition IODSOPCommonModule::setInstanceCreationDate | ( | const OFString & | value,
|  | const OFBool | checkValue = OFTrue )
| virtual

Set Instance Creation Date.

Parameters

  value | Value to be set (single value only) or "" for no value
  checkValue | Check 'value' for conformance with VR (TM) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setInstanceCreationTime()

virtual OFCondition IODSOPCommonModule::setInstanceCreationTime | ( | const OFString & | value,
|  | const OFBool | checkValue = OFTrue )
| virtual

Set Instance Creation Date.

Parameters

  value | Value to be set (single value only) or "" for no value
  checkValue | Check 'value' for conformance with VR (TM) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setInstanceCreatorUID()

virtual OFCondition IODSOPCommonModule::setInstanceCreatorUID | ( | const OFString & | value,
|  | const OFBool | checkValue = OFTrue )
| virtual

Set Instance Creator UID.

Parameters

  value | Value to be set (single value only) or "" for no value
  checkValue | Check 'value' for conformance with VR (UID) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setSOPClassUID()

virtual OFCondition IODSOPCommonModule::setSOPClassUID | ( | const OFString & | value,
|  | const OFBool | checkValue = OFTrue )
| virtual

Set SOP Class UID.

Parameters

  value | Value to be set (single value only) or "" for no value
  checkValue | Check 'value' for conformance with VR (UI) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setSOPInstanceUID()

virtual OFCondition IODSOPCommonModule::setSOPInstanceUID | ( | const OFString & | value,
|  | const OFBool | checkValue = OFTrue )
| virtual

Set SOP Instance UID.

Parameters

  value | Value to be set (single value only) or "" for no value
  checkValue | Check 'value' for conformance with VR (UI) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setSpecificCharacterSet()

virtual OFCondition IODSOPCommonModule::setSpecificCharacterSet | ( | const OFString & | value,
|  | const OFBool | checkValue = OFTrue )
| virtual

Set Specific Character Set.

The internal enumerated value is set accordingly. Please note that code extensions techniques are not supported. Therefore, only a single value can be passed.

Parameters

  value | Value to be set (single value only) or "" for no value
  checkValue | Check 'value' for conformance with VR (CS) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setTimeZoneOffsetFromUTC()

virtual OFCondition IODSOPCommonModule::setTimeZoneOffsetFromUTC | ( | const OFString & | value,
|  | const OFBool | checkValue = OFTrue ) const
| virtual

Set Timezone Offset From UTC.

Parameters

  value | Value to be set (single value only) or "" for no value. Encoded as an ASCII string in the format "&ZZXX". The components of this string, from left to right, are & = "+" or "-", and ZZ = Hours and XX = Minutes of offset.
  checkValue | Check 'value' for conformance with VR (SH) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

The documentation for this class was generated from the following file:

- dcmiod/include/dcmtk/dcmiod/modsopcommon.h

Generated on for DCMTK Version 3.7.0 by Doxygen 1.16.1